{ sources, pkgs }:

let
  # TODO: move this into a proper overlay of `pkgs` so that we don't need to track this for every and any package.
  colmena = pkgs.callPackage ../lib/colmena {
    colmena = pkgs.callPackage "${sources.colmena}/package.nix" { };
  };

  inherit (pkgs.lib) mapAttrs;

  inherit (pkgs)
    writeShellApplication
    jq
    nvd
    ;

  scripts = {
    cache-node = [ colmena ];
    check-deployment = [
      colmena
      jq
      nvd
    ];
    launch-vm = [ colmena ];
    list-nodes = [ jq ];
  };
in

mapAttrs (
  name: runtimeInputs:
  writeShellApplication {
    inherit name runtimeInputs;

    text = builtins.readFile ./${name}.sh;
  }
) scripts
